# WoodburyMatrices

[![Build Status](https://github.com/JuliaLinearAlgebra/WoodburyMatrices.jl/workflows/CI/badge.svg)](https://github.com/JuliaLinearAlgebra/WoodburyMatrices.jl/actions?query=workflow%3ACI+branch%3Amaster)
[![Coverage Status](http://codecov.io/github/JuliaLinearAlgebra/WoodburyMatrices.jl/coverage.svg?branch=master)](http://codecov.io/github/JuliaLinearAlgebra/WoodburyMatrices.jl?branch=master)
[![Aqua QA](https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg)](https://github.com/JuliaTesting/Aqua.jl)

This package provides support for the [Woodbury matrix identity](http://en.wikipedia.org/wiki/Woodbury_matrix_identity) for the Julia programming language.  This is a generalization of the [Sherman-Morrison formula](http://en.wikipedia.org/wiki/Sherman%E2%80%93Morrison_formula). Note that the Woodbury matrix identity is notorious for floating-point roundoff errors, so be prepared for a certain amount of inaccuracy in the result.

## Usage

### Woodbury Matrices
```julia
using WoodburyMatrices
W = Woodbury(A, U, C, V)
```
creates a `Woodbury` matrix from the `A`, `U`, `C`, and `V` matrices representing `A + U*C*V`. These matrices can be dense or sparse (or generally any type of `AbstractMatrix`), with the caveat that
`inv(inv(C) + V*(A\U))` will be calculated explicitly and hence needs to be representable with the available resources.
(In many applications, this is a fairly small matrix.)

Here are some of the things you can do with a Woodbury matrix:

- `Matrix(W)` converts to its dense representation.
- `W\b` solves the equation `W*x = b` for `x`.
- `W*x` computes the product.
- `det(W)` computes the determinant of `W`.
- `α*W` and `W1 + W2`.

It's worth emphasizing that `A` can be supplied as a factorization, which makes `W\b` and `det(W)` more efficient.

### SymWoodbury Matrices

```julia
using WoodburyMatrices
W = SymWoodbury(A, B, D)
```
creates a `SymWoodbury` matrix, a symmetric version of a Woodbury matrix representing `A + B*D*B'`. In addition to the features above, `SymWoodbury` also supports "squaring" `W*W`.

## Efficiency and thread-safety

If passed the keyword argument `allocatetmp=true`, (Sym)Woodbury allocates internal temporary storage for intermediate results in `W*v` and `W\v` where `v` is a vector.
This eliminates memory allocation for these common operations.

However, using the same `W` across multiple threads can lead to race conditions. Hence, this optimization is opt-in and should only be used if you know it is safe.

struct SymWoodbury{T,AType,BType,DType,DpType} <: AbstractWoodbury{T}
    A::AType
    B::BType
    D::DType
    Dp::DpType
    tmpN1::Union{Vector{T}, Nothing}
    tmpN2::Union{Vector{T}, Nothing}
    tmpk1::Union{Vector{T}, Nothing}
    tmpk2::Union{Vector{T}, Nothing}

    SymWoodbury{T}(A, B, D, Dp, tmpN1, tmpN2, tmpk1, tmpk2) where {T} =
        new{T,typeof(A),typeof(B),typeof(D),typeof(Dp)}(A, B, D, Dp, tmpN1, tmpN2, tmpk1, tmpk2)
end

"""
    W = SymWoodbury(A, B, D; allocatetmp::Bool=false)

Represent a matrix of the form `W = A + BDBᵀ`, where `A` and `D` are symmetric.
Equations `Wx = b` will be solved using the
[Woodbury matrix identity](https://en.wikipedia.org/wiki/Woodbury_matrix_identity).

If your main goal is to solve equations, it can be advantageous to supply
`A` as a factorization (e.g., `SymWoodbury(cholesky(A), B, D)` if `A` is a positive
semidefinite matrix).

This checks that `A` is symmetric; you can elide the check by passing a `Symmetric` matrix
or factorization.

See also [Woodbury](@ref), where `allocatetmp` is explained.
"""
function SymWoodbury(A, B::AbstractVecOrMat, D; allocatetmp::Bool=false)
    @noinline throwdmm(B, D, A) = throw(DimensionMismatch("Sizes of B ($(size(B))) and/or D ($(size(D))) are inconsistent with A ($(size(A)))"))

    n = size(A, 1)
    k = size(B, 2)
    if size(A, 2) != n || size(B, 1) != n || size(D,1) != k || size(D,2) != k
        throwdmm(B, D, A)
    end
    if !isa(A, Cholesky) && !isa(A, BunchKaufman) && !isa(A, LDLt)
        issymmetric(A) || throw(ArgumentError("A must be symmetric"))
    end
    issymmetric(D) || throw(ArgumentError("D must be symmetric"))
    Dp = safeinv(safeinv(D) .+ B'*(A\B))
    # temporary space for allocation-free solver (vector RHS only)
    T = typeof(float(zero(eltype(A)) * zero(eltype(B)) * zero(eltype(D))))
    if allocatetmp
        tmpN1 = Vector{T}(undef, n)
        tmpN2 = Vector{T}(undef, n)
        tmpk1 = Vector{T}(undef, k)
        tmpk2 = Vector{T}(undef, k)
    else
        tmpN1 = tmpN2 = tmpk1 = tmpk2 = nothing
    end

    SymWoodbury{T}(A, B, D, Dp, tmpN1, tmpN2, tmpk1, tmpk2)
end

convert(::Type{W}, O::SymWoodbury) where {W<:Woodbury} = Woodbury(O.A, O.B, O.D, O.B')

convert(::Type{Matrix{T}}, W::SymWoodbury) where {T} = convert(Matrix{T}, symmetrize!(Matrix(W.A) + W.B*W.D*W.B'))

# This allows a common interface with Woodbury
function Base.getproperty(O::SymWoodbury, name::Symbol)
    # SymWoodbury names
    name === :A && return getfield(O, :A)
    name === :B && return getfield(O, :B)
    name === :D && return getfield(O, :D)
    name === :Dp && return getfield(O, :Dp)
    name === :tmpN1 && return getfield(O, :tmpN1)
    name === :tmpN2 && return getfield(O, :tmpN2)
    name === :tmpk1 && return getfield(O, :tmpk1)
    name === :tmpk2 && return getfield(O, :tmpk2)
    # Woodbury names
    name === :U && return getfield(O, :B)
    name === :C && return getfield(O, :D)
    name === :Cp && return getfield(O, :Dp)
    name === :V && return getfield(O, :B)'
    error("property ", name, " not defined")
end

inv_invD_BtX(invD, B, X) = safeinv(invD - B'*X)
inv_invD_BtX(invD, B::AbstractVector, X) = safeinv(invD - dot(B,X))

function calc_inv(A, B, D)
    W = safeinv(A)
    X = W*B
    Z = inv_invD_BtX(-safeinv(D), B, X)
    SymWoodbury(symmetrize!(W), X, symmetrize!(Z))
end

inv(O::SymWoodbury{T,AType,BType,DType}) where {T<:Any, AType<:Any, BType<:AbstractVector, DType<:Real} =
  calc_inv(O.A, O.B, O.D)

inv(O::SymWoodbury{T,AType,BType,DType}) where {T<:Any, AType<:Any, BType<:Any, DType<:AbstractMatrix} =
  calc_inv(O.A, O.B, O.D)

# D is typically small, so this is acceptable.
inv(O::SymWoodbury{T,AType,BType,DType}) where {T<:Any, AType<:Any, BType<:Any, DType<:SparseMatrixCSC} =
  calc_inv(O.A, O.B, Matrix(O.D))

defaultfactor(::SymWoodbury, A) = bunchkaufman(A, true)
defaultfactor(::SymWoodbury, A::SymTridiagonal) = ldlt(A)
defaultfactor(::SymWoodbury, A::SparseMatrixCSC) = lu(A)

"""
    partialInv(O)

Get the factors `(X, Z)` in `Y + XZXᵀ == inv(A + BDBᵀ)`
"""
function partialInv(O::SymWoodbury)
    X = (O.A)\O.B
    invD = -1*inv(O.D)
    Z = inv_invD_BtX(invD, O.B, X)
    return (X,Z)
end

+(O::SymWoodbury, M::SymWoodbury)    = SymWoodbury(O.A + M.A, [O.B M.B],
                                                   cat(O.D,M.D; dims=(1,2)) )
*(α::Real, O::SymWoodbury)           = SymWoodbury(α*O.A, O.B, α*O.D)
+(O::SymWoodbury, M::AbstractMatrix) = SymWoodbury(O.A + M, O.B, O.D)

Base.copy(O::SymWoodbury{T}) where {T} = SymWoodbury(copy(O.A), copy(O.B), copy(O.D))

function square(O::SymWoodbury)
    A  = O.A^2
    AB = O.A*O.B
    Z  = [(AB + O.B) (AB - O.B)]
    R  = symmetrize!(O.D*(O.B'*O.B)*O.D/4)
    D  = [ O.D/2 + R  -R
          -R          -O.D/2 + R ]
    SymWoodbury(A, Z, D)
end

"""
The product of two SymWoodbury matrices will generally be a Woodbury Matrix,
except when they are the same, i.e. the user writes A'A or A*A' or A*A.

Z(A + B*D*Bᵀ) = ZA + ZB*D*Bᵀ

This package will not support support left multiplication by a generic
matrix, to keep return types consistent.
"""
function *(O1::SymWoodbury, O2::SymWoodbury)
    if (O1 === O2)
        return square(O1)
    elseif O1.A == O2.A && O1.B == O2.B && O1.D == O2.D
        return square(O1)
    else
        throw(MethodError("ERROR: To multiply two non-identical SymWoodbury matrices, first convert to Woodbury."))
    end
end

conjm(O::SymWoodbury, M) = SymWoodbury(symmetrize!(M*O.A*M'), M*O.B, symmetrize!(O.D))

Base.getindex(O::SymWoodbury, I::UnitRange, I2::UnitRange) =
  SymWoodbury(O.A[I,I], O.B[I,:], O.D);

adjoint(O::SymWoodbury{T}) where T<:Real = O   # it's Hermitian
transpose(O::SymWoodbury) = O

issymmetric(::SymWoodbury) = true

function show(io::IO, mime::MIME"text/plain", W::SymWoodbury)
    println(io, "Symmetric Woodbury factorization:\nA:")
    show(io, mime, W.A)
    print(io, "\nB:\n")
    Base.print_matrix(IOContext(io,:compact=>true), W.B)
    print(io, "\nD: ", W.D)
end
function show(io::IO, W::SymWoodbury)
    print(io, "SymWoodbury{$(eltype(W))}(A=")
    show(io, W.A)
    print(io, ", B=")
    show(io, W.B)
    print(io, ", D=")
    show(io, W.D)
    print(io, ")")
end


function symmetrize!(A::AbstractMatrix)
    axs = axes(A)
    axs[1] == axs[2] || error("matrix must be square")
    for j in axs[2], i in j+1:last(axs[1])
        a = (A[i,j] + A[j,i])/2
        A[i,j] = A[j,i] = a
    end
    return A
end

symmetrize!(x::Real) = x

@testset "Woodbury" begin
seed!(123)
n = 5

d = 1 .+ rand(n)
dl = -rand(n-1)
du = -rand(n-1)
v = randn(n)
B = randn(n,2)

U = randn(n,2)
V = randn(2,n)
C = randn(2,2)

for elty in (Float32, Float64, ComplexF32, ComplexF64, Int)
    if elty == Int
        seed!(61516384)
        d = rand(1:100, n)
        dl = -rand(0:10, n-1)
        du = -rand(0:10, n-1)
        v = rand(1:100, n)
        B = rand(1:100, n, 2)

        # Woodbury
        U = rand(1:100, n, 2)
        V = rand(1:100, 2, n)
        C = rand(1:100, 2, 2)
    else
        d = convert(Vector{elty}, d)
        dl = convert(Vector{elty}, dl)
        du = convert(Vector{elty}, du)
        v = convert(Vector{elty}, v)
        B = convert(Matrix{elty}, B)
        U = convert(Matrix{elty}, U)
        V = convert(Matrix{elty}, V)
        C = convert(Matrix{elty}, C)
    end
    ε = eps(abs2(float(one(elty))))
    T = Tridiagonal(dl, d, du)

    # Matrix for A
    for W in (Woodbury(T, U, C, V), Woodbury(T, U, C, V; allocatetmp=true))
        @test size(W, 1) == n
        @test size(W) == (n, n)
        @test axes(W) === (Base.OneTo(n), Base.OneTo(n))
        @test axes(W, 1) === Base.OneTo(n)
        F = Matrix(W)
        @test F ≈ T + U*C*V
        @test Array(W) == Matrix(W)
        if elty <: Real
            @test eltype(Matrix{Float64}(W)) === Float64
            @test eltype(Array{Float64}(W)) === Float64
        end
        @test W*v ≈ F*v
        iFv = F\v
        @test norm(W\v - iFv)/norm(iFv) <= n*cond(F)*ε # Revisit. Condition number is wrong
        @test norm(inv(W)*v - iFv)/norm(iFv) <= n*cond(F)*ε
        @test norm(diag(W) - diag(F)) <= n*cond(F)*ε # haven't thought about this error bound
        @test abs((det(W) - det(F))/det(F)) <= n*cond(F)*ε # Revisit. Condition number is wrong
        iWv = similar(iFv)
        if elty != Int
            iWv = ldiv!(W, copy(v))
            @test iWv ≈ iFv
        end
        @test W'*v ≈ F'*v
        @test transpose(W)*v ≈ transpose(F)*v
        @test (W + W) \ v ≈ (2*Matrix(W)) \ v
        @test (2W) \ v ≈ (W*2) \ v ≈ (2*Matrix(W)) \ v
        @test (W/2) \ v ≈ (Matrix(W)/2) \ v
        # Test a method used for ambiguity resolution
        if elty<:Union{Float32, Float64}
            R = randn(Complex{elty}, n, 2)
            @test W \ R ≈ Matrix(W) \ R
        end
    end

    Tsym = SymTridiagonal(d, du)
    Csym = [1 2; 2 3]
    @test !issymmetric(Woodbury(T, U, Csym, U'))
    @test !issymmetric(Woodbury(Tsym, U, C, U'))
    @test !issymmetric(Woodbury(Tsym, U, Csym, V))
    @test  issymmetric(Woodbury(Tsym, U, Csym, U'))

    # Diagonal matrix for A (lu(A) fails)
    D = Diagonal(d)
    W = Woodbury(D, U, C, V)
    F = Matrix(W)
    @test F ≈ D + U*C*V
    @test W*v ≈ F*v
    iFv = F\v
    @test norm(W\v - iFv)/norm(iFv) <= n*cond(F)*ε # Revisit. Condition number is wrong

    # Check division with diagonal matrix
    iFvmat = F\Diagonal(v)
    @test norm(W\Diagonal(v) - iFvmat)/norm(iFvmat) <= n*cond(F)*ε # Revisit. Condition number is wrong

    # Factorization for A
    W = Woodbury(lu(T), U, C, V)
    F = Matrix(W)
    @test_broken W*v ≈ F*v   # needs mul!(dst, ::LU, v, ...)
    iFv = F\v
    @test norm(W\v - iFv)/norm(iFv) <= n*cond(F)*ε # Revisit. Condition number is wrong
    @test abs((det(W) - det(F))/det(F)) <= n*cond(F)*ε # Revisit. Condition number is wrong
    iWv = similar(iFv)
    if elty != Int
        iWv = ldiv!(W, copy(v))
        @test iWv ≈ iFv
    end
    @test axes(W, 1) == axes(T, 1)
    @test axes(W) == axes(T)
end

# Sparse U and V
n = 5
d = 1 .+ rand(n)
dl = -rand(n-1)
du = -rand(n-1)
T = Tridiagonal(dl, d, du)
U = sprandn(n,2,0.2)
V = sprandn(2,n,0.2)
C = randn(2,2)
v = randn(n)
ε = eps()

W = Woodbury(T, U, C, V)
F = Matrix(W)
iFv = F\v
@test norm(W\v - iFv)/norm(iFv) <= n*cond(F)*ε

W = Woodbury(lu(T), U, C, V)
F = Matrix(W)
iFv = F\v
@test norm(W\v - iFv)/norm(iFv) <= n*cond(F)*ε

# Display
iob = IOBuffer()
show(iob, MIME("text/plain"), W)
str = String(take!(iob))
@test occursin("C:", str)
show(iob, W)
str = String(take!(iob))
@test occursin("Woodbury{Float64}", str)
@test occursin("C=", str)

# Vector-valued U and scalar-valued C
U = rand(n)
C = 2.3
V = rand(1,n)
W = Woodbury(T, U, C, V)
F = Matrix(W)

v = randn(n)
ε = eps()
iFv = F\v
@test norm(W\v - iFv)/norm(iFv) <= n*cond(F)*ε

@test Matrix(2*W) ≈ 2*Matrix(W)
@test Matrix(W*2) ≈ 2*Matrix(W)
R = rand(size(W)...)
@test Matrix(W + R) ≈ Matrix(W) + R
@test Matrix(R + W) ≈ Matrix(W) + R

show(iob, W)

Wc = copy(W)

# Mismatched sizes
@test_throws DimensionMismatch Woodbury(rand(5,5),rand(5,2),rand(2,3),rand(3,5))
@test_throws DimensionMismatch Woodbury(rand(5,5),rand(5,2),rand(3,3),rand(2,5))

# spec builder
n = 10
num_nz = 3
for i in 1:5  # repeat 5 times
    args = [(rand(1:n), rand(1:n), rand()) for j in 1:num_nz]
    r, v, c = WoodburyMatrices.sparse_factors(Float64, n, args...)
    out = r*v*c

    by_hand = zeros(n, n)
    for (i, j, v) in args
        by_hand[i, j] = v
    end

    @test maximum(abs,out - by_hand) == 0.0
end

# logdet
# make sure all matrices are PSD because I don't want complex numbers
W = Woodbury([randpsd(50) for _ in 1:4]...)
@test logdet(W) ≈ log(det(W)) ≈ logdet(Array(W))
@test all(logabsdet(W) .≈ logabsdet(Array(W)))

@testset "Empty U" begin
    A = Diagonal( Float64[1,2,3,4] )
    B = Matrix{Float64}(undef, 4, 0)
    D = Diagonal(Float64[])

    W = Woodbury( A, B, D, B')
    @test W \ [13, 14, 15, 16] ≈ Matrix(W) \ [13, 14, 15, 16]
    @test det(W) ≈ det(Matrix(W))
    @test logdet(W) ≈ logdet(Matrix(W))
    @test all(logabsdet(W) .≈ logabsdet(Matrix(W)))
end

end  # @testset "Woodbury"

# Used by Interpolations.jl

"""
Given a type `T`, an integer `n` and `m` tuples of the form (i, j, v), build
sparse matrices `rows`, `vals`, `cols` such that the product
`out = rows * vals * cols` is equivalent to:

```julia
out = zeros(T, n, n)

for (i, j, v) in args
    out[i, j] = v
end
```

The first two components (`i` and `j`) of each tuple should be integers
whereas the third component should be of type `T`

Example:


```
julia> r, v, c = WoodburyMatrices.sparse_factors(Float64, 3,
                                                 (1, 1, 2.0),
                                                 (2, 2, 3.0),
                                                 (3, 3, 4.0));

julia> r*c*v - Diagonal([2.0, 3.0, 4.0])
3x3 sparse matrix with 0 Float64 entries:
```

"""
function sparse_factors(::Type{T}, n::Int, args::Tuple{Int, Int, Any}...) where {T}
    m = length(args)
    rows = spzeros(T, n, m)
    cols = spzeros(T, m, n)
    vals = zeros(T, m, m)

    ix = 1
    for (i, (row, col, val)) in enumerate(args)
        rows[row, ix] = 1
        cols[ix, col] = 1
        vals[ix, ix] = val
        ix += 1
    end

    rows, vals, cols
end

using WoodburyMatrices
using Test

@testset "SymWoodbury" begin
seed!(123)
n = 5

for elty in (Float32, Float64, ComplexF32, ComplexF64, Int)

    elty = Float64

    a = rand(n); B = rand(n,2); D = Symmetric(rand(2,2)); v = rand(n)

    if elty == Int
        v = rand(1:100, n)
        a = rand(1:100, n)
        B = rand(1:100, 2, n)
        D = Symmetric(rand(1:100, 2, 2))
    else
        v = convert(Vector{elty}, v)
        a = convert(Vector{elty}, a)
        B = convert(Matrix{elty}, B)
        D = convert(Matrix{elty}, D)
    end

    ε = eps(abs2(float(one(elty))))
    A = Diagonal(a)

    for W in (SymWoodbury(A, B, D), SymWoodbury(A, B, D; allocatetmp=true), SymWoodbury(A, B[:,1][:], 2.))

        @test issymmetric(W)
        F = Matrix(W)
        @test (2*W)*v ≈ 2*(W*v)
        @test W'*v ≈ W*v
        @test (W'W)*v ≈ Matrix(W)*(Matrix(W)*v)
        @test (W*W)*v ≈ Matrix(W)*(Matrix(W)*v)
        @test (W*W')*v ≈ Matrix(W)*(Matrix(W)*v)
        @test W[1:3,1:3]*v[1:3] ≈ Matrix(W)[1:3,1:3]*v[1:3]
        @test sparse(W) ≈ Matrix(W)
        @test W === W'
        @test W*Matrix(1.0I, n, n) ≈ Matrix(W)
        @test W'*Matrix(1.0I, n, n) ≈ Matrix(W)

        Z = randn(n,n)
        @test Matrix(W*Z) ≈ Matrix(W)*Z

        R = rand(n,n)

        for v = (rand(n, 1), view(rand(n,1), 1:n), view(rand(n,2),1:n,1:2))
            @test (2*W)*v ≈ 2*(W*v)
            @test (W*2)*v ≈ 2*(W*v)
            @test (W/2)*v ≈ (W*v)/2
            @test (W'W)*v ≈ Matrix(W)*(Matrix(W)*v)
            @test (W*W)*v ≈ Matrix(W)*(Matrix(W)*v)
            @test (W*W')*v ≈ Matrix(W)*(Matrix(W)*v)
            @test W[1:3,1:3]*v[1:3] ≈ Matrix(W)[1:3,1:3]*v[1:3]
            @test Matrix(WoodburyMatrices.conjm(W, R)) ≈ R*Matrix(W)*R'
            @test Matrix(copy(W)'W)*v ≈ Matrix(W)*(Matrix(W)*v)
            @test Matrix(W + A) ≈ Matrix(W)+Matrix(A)
            @test Matrix(A + W) ≈ Matrix(W)+Matrix(A)
        end

        v = rand(n,1)
        W2 = convert(Woodbury, W)
        @test Matrix(W2) ≈ Matrix(W)

        if elty != Int
            @test inv(W)*v ≈ inv(Matrix(W))*v
            @test W\v ≈ inv(Matrix(W))*v
            @test WoodburyMatrices.partialInv(W)[1] ≈ inv(W).B
            @test WoodburyMatrices.partialInv(W)[2] ≈ inv(W).D
            @test det(W) ≈ det(Matrix(W))
        end

    end

end


for elty in (Float32, Float64, ComplexF32, ComplexF64, Int)

    elty = Float64

    a1 = rand(n); B1 = rand(n,2); D1 = Symmetric(rand(2,2)); v = rand(n)
    a2 = rand(n); B2 = rand(n,2); D2 = Symmetric(rand(2,2));

    if elty == Int
        v = rand(1:100, n)

        a1 = rand(1:100, n)
        B1 = rand(1:100, 2, n)
        D1 = Symmetric(rand(1:100, 2, 2))

        a2 = rand(1:100, n)
        B2 = rand(1:100, 2, n)
        D2 = Symmetric(rand(1:100, 2, 2))
    else
        v = convert(Vector{elty}, v)

        a1 = convert(Vector{elty}, a1)
        B1 = convert(Matrix{elty}, B1)
        D1 = convert(Matrix{elty}, D1)

        a2 = convert(Vector{elty}, a2)
        B2 = convert(Matrix{elty}, B2)
        D2 = convert(Matrix{elty}, D2)
    end

    ε = eps(abs2(float(one(elty))))

    A1 = Diagonal(a1)
    A2 = Matrix(Diagonal(a2))

    W1 = SymWoodbury(A1, B1, D1)
    W2 = SymWoodbury(A2, B2, D2)

    W1r = SymWoodbury(A1, B1[:,1][:], 2.)
    W2r = SymWoodbury(A2, B2[:,1][:], 3.)

    for (W1, W2) = ((W1,W2), (W1r, W2), (W1, W2r), (W1r,W2r))
        @test (W1 + W2)*v ≈ (Matrix(W1) + Matrix(W2))*v
        @test (Matrix(W1) + W2)*v ≈ (Matrix(W1) + Matrix(W2))*v
        @test (W1 + 2*Matrix(Diagonal((a1))))*v ≈ (Matrix(W1) + Matrix(2*Matrix(Diagonal((a1)))))*v
        @test_throws MethodError W1*W2
    end

end

# Sparse U and D

A = Diagonal((rand(n)))
B = sprandn(n,2,1.)
D = sprandn(2,2,1.); D = (D + D')/2
W = SymWoodbury(A, B, D)
v = randn(n)
vdiag = Diagonal(v)
V = randn(n,1)

@test size(W) == (n,n)
@test size(W,1) == n
@test size(W,2) == n

@test inv(W)*v ≈ inv(Matrix(W))*v
@test (2*W)*v ≈ 2*(W*v)
@test (W'W)*v ≈ Matrix(W)*(Matrix(W)*v)
@test (W*W)*v ≈ Matrix(W)*(Matrix(W)*v)
@test (W*W')*v ≈ Matrix(W)*(Matrix(W)*v)

@test inv(W)*vdiag ≈ W\vdiag
@test W\vdiag ≈ W\Matrix(vdiag)
@test inv(W)*vdiag ≈ inv(Matrix(W))*vdiag

@test inv(W)*V ≈ inv(Matrix(W))*V
@test (2*W)*V ≈ 2*(W*V)
@test (W'W)*V ≈ Matrix(W)*(Matrix(W)*V)
@test (W*W)*V ≈ Matrix(W)*(Matrix(W)*V)
@test (W*W')*V ≈ Matrix(W)*(Matrix(W)*V)

@test Matrix(2*W) ≈ 2*Matrix(W)
@test Matrix(W*2) ≈ 2*Matrix(W)
R = Symmetric(rand(size(W)...))
# Not sure when this got fixed, but check that failures are for a "known" reason
canadd = try (W + R; true;) catch err; (@test err isa MethodError && err.f == ldiv!; false;) end
if canadd
    @test Matrix(W + R) ≈ Matrix(W) + R
    @test Matrix(R + W) ≈ Matrix(W) + R
else
    @test_broken Matrix(W + R) ≈ Matrix(W) + R
    @test_broken Matrix(R + W) ≈ Matrix(W) + R
end
Wm = SymWoodbury(A, Matrix(B), D)
@test Matrix(Wm + R) ≈ Matrix(Wm) + R
@test Matrix(R + Wm) ≈ Matrix(Wm) + R

@test transpose(W)*v ≈ transpose(Matrix(W))*v

# Factorization for A
A = SymTridiagonal(rand(5).+2, rand(4))
B = rand(5)
D = 2
x = rand(5)
W1 = SymWoodbury(A, B, D)
@test W1 \ x ≈ Matrix(W1) \ x
for AA in (ldlt(A), cholesky(Matrix(A)), bunchkaufman(Matrix(A), true))
    W2 = SymWoodbury(AA, B, D)
    @test W2 \ x ≈ W1 \ x
end
A = Symmetric(rand(5, 5))
W1 = SymWoodbury(A, B, D)
@test W1 \ x ≈ Matrix(W1) \ x
for AA in (bunchkaufman(Matrix(A), true),)
    W2 = SymWoodbury(AA, B, D)
    @test W2 \ x ≈ W1 \ x
end
A = sparse(A)
W1 = SymWoodbury(A, B, D)
@test W1 \ x ≈ Matrix(W1) \ x

# Mismatched sizes
@test_throws DimensionMismatch SymWoodbury(rand(5,5),rand(5,2),rand(2,3))
@test_throws DimensionMismatch SymWoodbury(rand(5,5),rand(5,2),rand(3,3))
@test_throws DimensionMismatch SymWoodbury(rand(5,5),rand(3),1.)

# Asymmetric
@test_throws ArgumentError SymWoodbury(rand(5,5),rand(5,2),rand(2,2))

# Display
iob = IOBuffer()
show(iob, MIME("text/plain"), W)
str = String(take!(iob))
@test occursin("D:", str)
show(iob, W)
str = String(take!(iob))
@test occursin("SymWoodbury{Float64}", str)
@test occursin("D=", str)

# logdet
# make sure all matrices are PSD because I don't want complex numbers
W = SymWoodbury([randpsd(50) for _ in 1:3]...)
@test logdet(W) ≈ log(det(W)) ≈ logdet(Array(W))
@test all(logabsdet(W) .≈ logabsdet(Array(W)))

@testset "Diagonal (issue #35)" begin
    A = Diagonal( Float64[1,2,3,4] )
    V = [5  6  7  8;
         9 10 11 12]
    U = V'
    D = Matrix( I, 2, 2 )

    W = SymWoodbury( A, U, D )
    @test W \ [13, 14, 15, 16] ≈ Matrix(W) \ [13, 14, 15, 16]
end

@testset "Empty B" begin
    A = Diagonal( Float64[1,2,3,4] )
    B = Matrix{Float64}(undef, 4, 0)
    D = Diagonal(Float64[])

    W = SymWoodbury( A, B, D)
    @test W \ [13, 14, 15, 16] ≈ Matrix(W) \ [13, 14, 15, 16]
    @test det(W) ≈ det(Matrix(W))
    @test logdet(W) ≈ logdet(Matrix(W))
    @test all(logabsdet(W) .≈ logabsdet(Matrix(W)))
end

end # @testset "SymWoodbury"

struct Woodbury{T,AType,UType,VType,CType,CpType} <: AbstractWoodbury{T}
    A::AType
    U::UType
    C::CType
    Cp::CpType
    V::VType
    tmpN1::Union{Vector{T}, Nothing}
    tmpN2::Union{Vector{T}, Nothing}
    tmpk1::Union{Vector{T}, Nothing}
    tmpk2::Union{Vector{T}, Nothing}

    Woodbury{T}(A, U, C, Cp, V, tmpN1, tmpN2, tmpk1, tmpk2) where {T} =
        new{T,typeof(A),typeof(U),typeof(V),typeof(C),typeof(Cp)}(A, U, C, Cp, V, tmpN1, tmpN2, tmpk1, tmpk2)
end

"""
    W = Woodbury(A, U, C, V; allocatetmp::Bool=false)

Represent a matrix `W = A + UCV`.
Equations `Wx = b` will be solved using the
[Woodbury matrix identity](https://en.wikipedia.org/wiki/Woodbury_matrix_identity).

If your main goal is to solve equations, it's often advantageous to supply
`A` as a factorization (e.g., `Woodbury(lu(A), U, C, V)`).

If `allocatetmp` is true, temporary storage used for intermediate steps in
multiplication and division will be allocated.

!!! warning
    If you'll use the same `W` in multiple threads, you should use `allocatetmp=false`
    or risk data races.


See also [SymWoodbury](@ref).

"""
function Woodbury(A, U::AbstractMatrix, C, V::AbstractMatrix; allocatetmp::Bool=false)
    @noinline throwdmm1(U, V, A) = throw(DimensionMismatch("Sizes of U ($(size(U))) and/or V ($(size(V))) are inconsistent with A ($(size(A)))"))
    @noinline throwdmm2(k) = throw(DimensionMismatch("C should be $(k)x$(k)"))

    N = size(A, 1)
    k = size(U, 2)
    if size(A, 2) != N || size(U, 1) != N || size(V, 1) != k || size(V, 2) != N
        throwdmm1(U, V, A)
    end
    if k > 1
        if size(C, 1) != k || size(C, 2) != k
            throwdmm2(k)
        end
    end
    Cp = safeinv(safeinv(C) .+ V*(A\U))
    # temporary space for allocation-free solver (vector RHS only)
    T = typeof(float(zero(eltype(A)) * zero(eltype(U)) * zero(eltype(C)) * zero(eltype(V))))
    if allocatetmp
        tmpN1 = Vector{T}(undef, N)
        tmpN2 = Vector{T}(undef, N)
        tmpk1 = Vector{T}(undef, k)
        tmpk2 = Vector{T}(undef, k)
    else
        tmpN1 = tmpN2 = tmpk1 = tmpk2 = nothing
    end

    Woodbury{T}(A, U, C, Cp, V, tmpN1, tmpN2, tmpk1, tmpk2)
end

Woodbury(A, U::AbstractVector{T}, C, V::AbstractMatrix{T}) where {T} = Woodbury(A, reshape(U, length(U), 1), C, V)

# Woodbury(A, U::AbstractVector, C, V::Adjoint) = Woodbury(A, U, C, Matrix(V))

function show(io::IO, mime::MIME"text/plain", W::Woodbury)
    println(io, "Woodbury factorization:\nA:")
    show(io, mime, W.A)
    print(io, "\nU:\n")
    Base.print_matrix(IOContext(io, :compact=>true), W.U)
    if isa(W.C, Matrix)
        print(io, "\nC:\n")
        Base.print_matrix(IOContext(io, :compact=>true), W.C)
    else
        print(io, "\nC: ", W.C)
    end
    print(io, "\nV:\n")
    Base.print_matrix(IOContext(io, :compact=>true), W.V)
end
function show(io::IO, W::Woodbury)
    print(io, "Woodbury{$(eltype(W))}(A=")
    show(io, W.A)
    print(io, ", U=")
    show(io, W.U)
    print(io, ", C=")
    show(io, W.C)
    print(io, ", V=")
    show(io, W.V)
    print(io, ")")
end


copy(W::Woodbury) = Woodbury(W.A, W.U, W.C, W.V)

function inv(W::AbstractWoodbury)
    A′ = inv(W.A)
    U′ = W.A \ W.U
    C′ = -W.Cp
    V′ = W.V*A′
    return Woodbury(A′, U′, C′, V′)
end

# multiplying everything out would be O(m^2 k + m k^2) operations
# best I could think of was O(m^2 k) operations
diag(W::AbstractWoodbury) = diag(W.A) + vec(sum(W.U .* (W.C * W.V)', dims=2))

+(W::Woodbury, X::Woodbury)       = Woodbury(W.A + X.A, [W.U X.U],
                                             cat(W.C, X.C; dims=(1,2)), [W.V; X.V])
*(α::Real, W::Woodbury)           = Woodbury(α*W.A, W.U, α*W.C, W.V)
+(W::Woodbury, M::AbstractMatrix) = Woodbury(W.A + M, W.U, W.C, W.V)

adjoint(W::Woodbury) = Woodbury(adjoint(W.A), adjoint(W.V), adjoint(W.C), adjoint(W.U))
transpose(W::Woodbury) = Woodbury(transpose(W.A), transpose(W.V), transpose(W.C), transpose(W.U))

# We'd like to implement `issymmetric` as
#     issymmetric(W::Woodbury) = issymmetric(W.A) && issymmetric(W.C) && W.U == W.V'
# but this only represents a quick check in favorable cases, as it is possible for A + UCV
# to be symmetric even if the pieces are not.
# (Example: A + U*C*(-U') = A - U*C*U'.)
# Thus we have to fall back to the dense implementation.
# See `SymWoodbury` for a guaranteed-symmetric version.
function issymmetric(W::Woodbury)
    issymmetric(W.A) && issymmetric(W.C) && W.U == W.V' && return true
    return issymmetric(Matrix(W))
end

module WoodburyMatrices

using LinearAlgebra
import LinearAlgebra: det, logdet, logabsdet, ldiv!, mul!, adjoint, transpose, diag, issymmetric
import Base: +, *, \, inv, /, convert, copy, show, similar, axes, size
using SparseArrays

export AbstractWoodbury, Woodbury, SymWoodbury

abstract type AbstractWoodbury{T} <: Factorization{T} end

safeinv(A) = inv(A)
safeinv(A::SparseMatrixCSC) = safeinv(Matrix(A))

include("woodbury.jl")
include("symwoodbury.jl")
include("sparsefactors.jl")

# Traits and algorithms expressible in terms of AbstractWoodbury

size(W::AbstractWoodbury) = size(W.A)
size(W::AbstractWoodbury, d) = size(W.A, d)
axes(W::AbstractWoodbury) = axes(W.A)
axes(W::AbstractWoodbury, d) = _axes(W.A, d)
_axes(F::Factorization, dim::Int) = hasmethod(axes, Tuple{typeof(F), Int}) ? axes(F, dim) : Base.OneTo(size(F, dim))
_axes(A::AbstractArray, dim::Int) = axes(A, dim)

Base.Matrix(W::AbstractWoodbury{T}) where {T} = Matrix{T}(W)
Base.Matrix{T}(W::AbstractWoodbury) where {T} = convert(Matrix{T}, W)
Base.Array(W::AbstractWoodbury) = Matrix(W)
Base.Array{T}(W::AbstractWoodbury) where T = Matrix{T}(W)

convert(::Type{Matrix{T}}, W::AbstractWoodbury) where {T} = convert(Matrix{T}, Matrix(W.A) + W.U*W.C*W.V)

# This is a slow hack, but generally these matrices aren't sparse.
SparseArrays.sparse(W::AbstractWoodbury) = sparse(Matrix(W))

# Multiplication

*(W::AbstractWoodbury, B::AbstractMatrix)=W.A*B + W.U*(W.C*(W.V*B))

function *(W::AbstractWoodbury{T}, x::AbstractVector{S}) where {T,S}
    TS = Base.promote_op(LinearAlgebra.matprod, T, S)
    mul!(similar(x, TS, size(W,1)), W, x)
end

function mul!(dest, W::AbstractWoodbury, x::AbstractVector)
    # A reduced-allocation optimization (using temp storage for the multiplications)
    if W.tmpN1 !== nothing
        mul!(W.tmpN1, W.A, x)
        mul!(W.tmpk1, W.V, x)
        mul!(W.tmpk2, W.C, W.tmpk1)
        mul!(W.tmpN2, W.U, W.tmpk2)
        dest .= W.tmpN1 .+ W.tmpN2
    else
        dest .= W.A * x + W.U * (W.C * (W.V * x))
    end
    return dest
end

# Division

function _ldiv(W::AbstractWoodbury, R::AbstractVecOrMat)
    AinvR = W.A\R
    return AinvR - W.A\(W.U*(W.Cp*(W.V*AinvR)))
end

\(W::AbstractWoodbury, R::AbstractMatrix) = _ldiv(W, R)
\(W::AbstractWoodbury{T}, R::Matrix{Complex{T}}) where T<:Union{Float32, Float64} = _ldiv(W, R)  # ambiguity resolution
\(W::AbstractWoodbury, D::Diagonal) = _ldiv(W, D)

ldiv!(W::AbstractWoodbury, B::AbstractVector) = ldiv!(B, W, B)

function ldiv!(dest::AbstractVector, W::AbstractWoodbury, B::AbstractVector)
    @noinline throwdmm(W, B) = throw(DimensionMismatch("Vector length $(length(B)) must match matrix size $(size(W,1))"))

    length(B) == size(W, 1) || throwdmm(W, B)
    _ldiv!(dest, W, W.A, B)
    return dest
end

function _ldiv!(dest, W::AbstractWoodbury, A::Union{Factorization,Diagonal}, B)
    if W.tmpN1 !== nothing
        ldiv!(W.tmpN1, A, B)
        mul!(W.tmpk1, W.V, W.tmpN1)
        mul!(W.tmpk2, W.Cp, W.tmpk1)
        mul!(W.tmpN2, W.U, W.tmpk2)
        ldiv!(A, W.tmpN2)
        for i in eachindex(W.tmpN2)
            dest[i] = W.tmpN1[i] - W.tmpN2[i]
        end
    else
        copyto!(dest, _ldiv(W, B))
    end
    return dest
end
_ldiv!(dest, W, A, B) = _ldiv!(dest, W, defaultfactor(W, A), B)

defaultfactor(::AbstractWoodbury, A) = lu(A)

function det(W::AbstractWoodbury)
    ret = det(W.A)
    if !isempty(W.C)
        ret *= det(W.C)/det(W.Cp)
    end
    return ret
end
function logdet(W::AbstractWoodbury)
    ret = logdet(W.A)
    if !isempty(W.C)
        ret += logdet(W.C) - logdet(W.Cp)
    end
    return ret
end
function logabsdet(W::AbstractWoodbury)
    lad_A = logabsdet(W.A)
    isempty(W.C) && return lad_A
    lad_C = logabsdet(W.C)
    lad_Cp = logabsdet(W.Cp)
    lad = lad_A[1] + lad_C[1] - lad_Cp[1]
    s = lad_A[2] * lad_C[2] / lad_Cp[2]
    return lad, s
end

*(W::AbstractWoodbury, α::Real) = α*W
/(W::AbstractWoodbury, α::Real) = (1/α)*W
+(M::AbstractMatrix, W::AbstractWoodbury) = W + M

end

using WoodburyMatrices
using LinearAlgebra, SparseArrays, Test
using Aqua
using Random: seed!

@testset "Aqua" begin
    Aqua.test_all(WoodburyMatrices)
end

# helper function for testing logdet
function randpsd(sidelength)
    Q = randn(sidelength, sidelength)
    return Q * Q'
end

include("woodbury.jl")
include("symwoodbury.jl")
